<?php
/*
  Relchanger plugin
  (P) PSNet, 2008 - 2012
  http://psnet.lookformp3.net/
  http://livestreet.ru/profile/PSNet/
  http://livestreetcms.com/profile/PSNet/
*/

class PluginRelchanger_ModuleText extends PluginRelchanger_Inherit_ModuleText {

  public function Parser ($sText) {
    $NewResult = parent::Parser ($sText);
    $NewResult = $this -> RebuildRelTag ($NewResult);
    return $NewResult;
  }
  
  // ---
  
  private static function ParseMatches ($aMatches) {
    $aMatches [1] = empty ($aMatches [1]) ? ' ' : $aMatches [1];
    $aMatches [4] = empty ($aMatches [4]) ? ' ' : $aMatches [4];
    
    $sRelLink = 'rel="nofollow"';
    $sBeforeLink = '<noindex>';
    $sAfterLink = '</noindex>';
    
    if ((strpos ($aMatches [1], 'rel') !== false) or (strpos ($aMatches [4], 'rel') !== false)) {
      $sRelLink = '';
    }
    if ((!Config::Get ('plugin.relchanger.Wrap_Links_With_Noindex')) or ($sRelLink == '')) {
      $sBeforeLink = $sAfterLink = '';
    }
    
    return ($sBeforeLink . '<a' . $aMatches [1] . 'href="http' . $aMatches [2] . '://' . $aMatches [3] . '"' .
      $aMatches [4] .
      $sRelLink .
      '>' .
      $aMatches [5] .
      '</a>' . $sAfterLink);
  }
  
  // ---
  
  private function RebuildRelTag ($sText) {
    return preg_replace_callback ('#<a([^<]*)href=["\']http([s]?)://([a-z0-9.-]*[\/]?)["\']([^<]*)>(.*)</a>#isumU', 'PluginRelchanger_ModuleText::ParseMatches', $sText);
  }

}

?>